<%@ Page Language="C#" AutoEventWireup="true" %>
<%@ Import namespace="TDS" %>
<%@ Import namespace="System.Xml" %>
<%
// what is the maximum default total of items that are allowed in the queue
int defaultMaxItems = 100;
// what is the default queue to be looked at
string defaultQueue = "1";
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head><title></title></head>
<body>  
<%     
    TDSE tdse = new TDSE();
    XmlDocument itemsXmlDoc = new XmlDocument();
    XmlNodeList itemNodes;
    
    // get the queue id for the Filter
    string queue = defaultQueue;
    if (Request.QueryString["queue"] != null)
        queue = Request.QueryString["queue"];

    // get the maximum amount of items that should be on the queue
    int maxItems = defaultMaxItems;
    if (Request.QueryString["max"] != null)
        maxItems = Convert.ToInt32(Request.QueryString["max"]);
    
    // do the TCM shizzle
    tdse.Impersonate(Request.ServerVariables["REMOTE_USER"]);
    tdse.Initialize();
    ManagementInfo managementInfo = tdse.GetManagementInfo();

    ListRowFilter filter = tdse.CreateListRowFilter();
    filter.SetCondition("InfoType", queue);

    String itemsXml = managementInfo.GetListPublishTransactions(filter);
    itemsXmlDoc.LoadXml(itemsXml);

    XmlNamespaceManager namespaceManager = new XmlNamespaceManager(itemsXmlDoc.NameTable);
    namespaceManager.AddNamespace("tcm", "http://www.tridion.com/ContentManager/5.0");

    itemNodes = itemsXmlDoc.SelectNodes("tcm:ListPublishTransactions/tcm:Item", namespaceManager);
    
    // get the total number of items and output accordingly
    int itemsCount = itemNodes.Count;
    if (itemsCount > maxItems) {
        %>Error, number of items in the queue exceeds limit. Queue is now at: <%=itemsCount%> of a max of <%=maxItems%> items.<%
    } else { 
        %>Monitoring TestPage<%
    }
                   
    System.Runtime.InteropServices.Marshal.ReleaseComObject(tdse);
    System.Runtime.InteropServices.Marshal.ReleaseComObject(managementInfo);
    System.Runtime.InteropServices.Marshal.ReleaseComObject(filter);

    itemsXmlDoc = null;
    itemNodes = null;
    queue = null;
    defaultQueue = null;
    maxItems = 0;
    defaultMaxItems = 0;
    itemsCount = 0;             
%>
</body>
</html>